## pgloader 2.2.5

=== Makefile ===
# $Id: Makefile,v 1.9 2007/12/08 20:19:32 dim Exp $
#
# Makefile for debian packaging purpose, make install not intended to work.

DOCS    = pgloader.1.txt
CVSROOT = $(shell cat CVS/Root)
VERSION = $(shell ./pgloader.py --version | cut -d' ' -f3)

# debian setting
DESTDIR =

libdir   = $(DESTDIR)/usr/share/python-support/pgloader
exdir    = $(DESTDIR)/usr/share/doc/pgloader

pgloader = pgloader.py
examples = examples
libs = $(wildcard pgloader/*.py)
refm = $(wildcard reformat/*.py)

DEBDIR = /tmp/pgloader
EXPORT = $(DEBDIR)/export/pgloader
ORIG   = $(DEBDIR)/export/pgloader_$(VERSION).orig.tar.gz

install:
	install -m 755 $(pgloader) $(DESTDIR)/usr/bin/pgloader
	install -m 755 -d $(libdir)/pgloader
	install -m 755 -d $(libdir)/reformat

	cp -a $(libs) $(libdir)/pgloader
	cp -a $(refm) $(libdir)/reformat
	cp -a $(examples) $(exdir)

html: $(DOCS)
	asciidoc -a toc $<

site: html
	scp ${DOCS:.txt=.html} cvs.pgfoundry.org:htdocs

pgloader.1.xml: $(DOCS)
	asciidoc -d manpage -b docbook $<

man: ${DOCS:.txt=.xml}
	xmlto man $<

deb:
	# working copy from where to make the .orig archive
	rm -rf $(DEBDIR)	
	mkdir -p $(DEBDIR)/pgloader
	mkdir -p $(EXPORT)
	cp -a . $(EXPORT)
	for n in ".#*" "*~" "*.pyc" "build-stamp" "configure-stamp"; do \
	  find $(EXPORT) -name "$$n" -print0|xargs -0 echo rm -f; \
	  find $(EXPORT) -name "$$n" -print0|xargs -0 rm -f; \
	done
	find $(EXPORT) -type d -name CVS -print0|xargs -0 rm -rf

	# prepare the .orig without the debian/ packaging stuff
	cp -a $(EXPORT) $(DEBDIR)
	rm -rf $(DEBDIR)/pgloader/debian
	(cd $(DEBDIR) && tar czf $(ORIG) pgloader)

	# build the debian package and copy them to ..
	(cd $(EXPORT) && debuild)
	cp -a $(DEBDIR)/export/pgloader_$(VERSION)* ..

## pgloader 2.3.1

=== Makefile ===
# $Id: Makefile,v 1.18 2008/03/10 15:29:45 dim Exp $
#
# Makefile for debian packaging purpose, make install not intended to work.

DOCS    = pgloader.1.txt
TODO    = TODO.txt
BUGS    = BUGS.txt
CVSROOT = $(shell cat CVS/Root)
VERSION = $(shell ./pgloader.py --version |cut -d' ' -f3)
SHORTVER= $(shell ./pgloader.py --version |cut -d' ' -f3 |cut -d '~' -f1)

# debian setting
DESTDIR =

libdir   = $(DESTDIR)/usr/share/python-support/pgloader
exdir    = $(DESTDIR)/usr/share/doc/pgloader

pgloader = pgloader.py
examples = examples
libs = $(wildcard pgloader/*.py)
refm = $(wildcard reformat/*.py)

DEBDIR = /tmp/pgloader
EXPORT = $(DEBDIR)/export/pgloader-$(VERSION)
ORIG   = $(DEBDIR)/export/pgloader_$(VERSION).orig.tar.gz
ARCHIVE= $(DEBDIR)/export/pgloader-$(VERSION).tar.gz

install:
	install -m 755 $(pgloader) $(DESTDIR)/usr/bin/pgloader
	install -m 755 -d $(libdir)/pgloader
	install -m 755 -d $(libdir)/reformat

	cp -a $(libs) $(libdir)/pgloader
	cp -a $(refm) $(libdir)/reformat
	cp -a $(examples) $(exdir)
	cp -a $(TODO) $(BUGS) $(DESTDIR)/usr/share/doc/pgloader

html: $(DOCS)
	asciidoc -a toc $<

todo: $(TODO)
	asciidoc -a toc $<

bugs: $(BUGS)
	asciidoc -a toc $<

site: html
	scp ${DOCS:.txt=.html} cvs.pgfoundry.org:htdocs

pgloader.1.xml: $(DOCS)
	asciidoc -d manpage -b docbook $<

man: ${DOCS:.txt=.xml}
	xmlto man $<

doc: man html todo bugs

clean:
	rm -f *.xml *.html *.1 *~

deb:
	# working copy from where to make the .orig archive
	rm -rf $(DEBDIR)	
	mkdir -p $(DEBDIR)/pgloader-$(VERSION)
	mkdir -p $(EXPORT)
	cp -a . $(EXPORT)

	# get rid of temp and build files
	for n in ".#*" "*~" "*.pyc" "build-stamp" "configure-stamp" "parallel.o*"; do \
	  find $(EXPORT) -name "$$n" -print0|xargs -0 echo rm -f; \
	  find $(EXPORT) -name "$$n" -print0|xargs -0 rm -f; \
	done

	# get rid of CVS dirs
	for n in "CVS" "CVSROOT"; do \
	  find $(EXPORT) -type d -name "$$n" -print0|xargs -0 rm -rf; \
	  find $(EXPORT) -type d -name "$$n" -print0|xargs -0 rm -rf; \
	done

	# prepare the .orig without the debian/ packaging stuff
	cp -a $(EXPORT) $(DEBDIR)
	rm -rf $(DEBDIR)/pgloader-$(VERSION)/debian
	(cd $(DEBDIR) && tar czf $(ORIG) pgloader-$(VERSION))

	# have a copy of the $ORIG file named $ARCHIVE for non-debian packagers
	cp $(ORIG) $(ARCHIVE)

	# build the debian package and copy them to ..
	(cd $(EXPORT) && debuild)
	cp -a $(DEBDIR)/export/pgloader[_-]$(VERSION)* ..
	cp -a $(ARCHIVE) ..

## pgloader 2.3.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.18 2008/03/10 15:29:45 dim Exp $
+# $Id: Makefile,v 1.19 2008/06/03 12:58:14 dim Exp $
 #
 # Makefile for debian packaging purpose, make install not intended to work.

## pgloader 2.3.3~dev3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.19 2008/06/03 12:58:14 dim Exp $
+# $Id: Makefile,v 1.19 2008-06-03 12:58:14 dim Exp $
 #
 # Makefile for debian packaging purpose, make install not intended to work.
 
@@ -20,7 +20,8 @@
 libs = $(wildcard pgloader/*.py)
 refm = $(wildcard reformat/*.py)
 
-DEBDIR = /tmp/pgloader
+TMPDIR?= /tmp
+DEBDIR = $(TMPDIR)/pgloader
 EXPORT = $(DEBDIR)/export/pgloader-$(VERSION)
 ORIG   = $(DEBDIR)/export/pgloader_$(VERSION).orig.tar.gz
 ARCHIVE= $(DEBDIR)/export/pgloader-$(VERSION).tar.gz
@@ -58,12 +59,12 @@
 clean:
 	rm -f *.xml *.html *.1 *~
 
-deb:
+prepare-deb:
 	# working copy from where to make the .orig archive
 	rm -rf $(DEBDIR)	
 	mkdir -p $(DEBDIR)/pgloader-$(VERSION)
 	mkdir -p $(EXPORT)
-	cp -a . $(EXPORT)
+	rsync -Ca . $(EXPORT)
 
 	# get rid of temp and build files
 	for n in ".#*" "*~" "*.pyc" "build-stamp" "configure-stamp" "parallel.o*"; do \
@@ -71,21 +72,25 @@
 	  find $(EXPORT) -name "$$n" -print0|xargs -0 rm -f; \
 	done
 
-	# get rid of CVS dirs
-	for n in "CVS" "CVSROOT"; do \
-	  find $(EXPORT) -type d -name "$$n" -print0|xargs -0 rm -rf; \
-	  find $(EXPORT) -type d -name "$$n" -print0|xargs -0 rm -rf; \
-	done
-
 	# prepare the .orig without the debian/ packaging stuff
-	cp -a $(EXPORT) $(DEBDIR)
+	rsync -Ca $(EXPORT) $(DEBDIR)
 	rm -rf $(DEBDIR)/pgloader-$(VERSION)/debian
 	(cd $(DEBDIR) && tar czf $(ORIG) pgloader-$(VERSION))
 
 	# have a copy of the $ORIG file named $ARCHIVE for non-debian packagers
 	cp $(ORIG) $(ARCHIVE)
 
-	# build the debian package and copy them to ..
+debuild:
 	(cd $(EXPORT) && debuild)
+
+debuild-unsign:
+	(cd $(EXPORT) && debuild -us -uc)
+
+copy-package:
 	cp -a $(DEBDIR)/export/pgloader[_-]$(VERSION)* ..
 	cp -a $(ARCHIVE) ..
+
+deb: prepare-deb debuild copy-package
+
+deb-unsign: prepare-deb debuild-unsign copy-package
+

## pgloader 3.1.0+dfsg

=== Makefile ===
# pgloader build tool
APP_NAME   = pgloader
VERSION    = 3.1.0

# use either sbcl or ccl
CL	   = sbcl

LISP_SRC   = $(wildcard src/*lisp) \
             $(wildcard src/pgsql/*lisp) \
             $(wildcard src/sources/*lisp) \
             pgloader.asd

BUILDDIR   = build
LIBS       = $(BUILDDIR)/libs.stamp
QLDIR      = $(BUILDDIR)/quicklisp
MANIFEST   = $(BUILDDIR)/manifest.ql
LATEST     = $(BUILDDIR)/pgloader-latest.tgz
PGLOADER   = $(BUILDDIR)/bin/$(APP_NAME)

BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl
BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl

ifeq ($(CL),sbcl)
BUILDAPP   = $(BUILDAPP_SBCL)
CL_OPTS    = --no-sysinit --no-userinit
else
BUILDAPP   = $(BUILDAPP_CCL)
CL_OPTS    = --no-init
endif

COMPRESS_CORE ?= yes

ifeq ($(CL),sbcl)
ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
else
COMPRESS_CORE_OPT = 
endif
endif

ifeq ($(CL),sbcl)
BUILDAPP_OPTS =          --require sb-posix                      \
                         --require sb-bsd-sockets                \
                         --require sb-rotate-byte
endif

DEBUILD_ROOT = /tmp/pgloader

all: $(PGLOADER)

clean:
	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER)

docs:
	ronn -roff pgloader.1.md

$(QLDIR)/local-projects/cl-ixf:
	git clone https://github.com/dimitri/cl-ixf.git $@

$(QLDIR)/setup.lisp:
	mkdir -p $(BUILDDIR)
	curl -o $(BUILDDIR)/quicklisp.lisp http://beta.quicklisp.org/quicklisp.lisp
	$(CL) $(CL_OPTS) --load $(BUILDDIR)/quicklisp.lisp                         \
             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp")' \
             --eval '(quit)'

quicklisp: $(QLDIR)/setup.lisp ;

$(LIBS): $(QLDIR)/setup.lisp $(QLDIR)/local-projects/cl-ixf
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
             --eval '(push "$(PWD)/" asdf:*central-registry*)'      \
             --eval '(ql:quickload "pgloader")'                     \
             --eval '(quit)'
	touch $@

libs: $(LIBS) ;

$(MANIFEST): $(LIBS)
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:write-asdf-manifest-file "$(MANIFEST)")'  \
             --eval '(quit)'

manifest: $(MANIFEST) ;

$(BUILDAPP_CCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

$(BUILDAPP_SBCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

buildapp: $(BUILDAPP) ;

$(PGLOADER): $(MANIFEST) $(BUILDAPP) $(LISP_SRC)
	mkdir -p $(BUILDDIR)/bin
	$(BUILDAPP)      --logfile /tmp/build.log                \
                         $(BUILDAPP_OPTS)                        \
                         --sbcl $(CL)                            \
                         --asdf-path .                           \
                         --asdf-tree $(QLDIR)/local-projects     \
                         --manifest-file $(MANIFEST)             \
                         --asdf-tree $(QLDIR)/dists              \
                         --asdf-path .                           \
                         --load-system $(APP_NAME)               \
                         --load src/hooks.lisp                   \
                         --entry pgloader:main                   \
                         --dynamic-space-size 4096               \
                         $(COMPRESS_CORE_OPT)                    \
                         --output $@

pgloader: $(PGLOADER) ;

pgloader-standalone:
	$(BUILDAPP)    --require sb-posix                      \
                       --require sb-bsd-sockets                \
                       --require sb-rotate-byte                \
                       --load-system pgloader                  \
                       --entry pgloader:main                   \
                       --dynamic-space-size 4096               \
                       --compress-core                         \
                       --output $(PGLOADER)

test: $(PGLOADER)
	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C test regress

deb:
	# intended for use on a debian system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	rsync -Ca --exclude 'build'                      		  \
		  --exclude '.vagrant'                   		  \
		  --exclude 'test/sqlite-chinook.load'   		  \
		  --exclude 'test/sqlite'                		  \
		  --exclude 'test/data/2013_Gaz_113CDs_national.txt'      \
		  --exclude 'test/data/reg2013.dbf'      		  \
		  --exclude 'test/data/sakila-db.zip'    		  \
              ./ $(DEBUILD_ROOT)/
	cd $(DEBUILD_ROOT) && make -f debian/rules orig
	cd $(DEBUILD_ROOT) && debuild -us -uc -sa
	cp -a /tmp/pgloader_* /tmp/cl-pgloader* build/

rpm:
	# intended for use on a CentOS or other RPM based system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)
	rsync -Ca --exclude=build/* ./ $(DEBUILD_ROOT)/
	cd /tmp && tar czf $(HOME)/rpmbuild/SOURCES/pgloader-$(VERSION).tar.gz pgloader
	cd $(DEBUILD_ROOT) && rpmbuild -ba pgloader.spec
	cp -a $(HOME)/rpmbuild/SRPMS/*rpm build
	cp -a $(HOME)/rpmbuild/RPMS/x86_64/*rpm build

pkg:
	# intended for use on a MacOSX system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	mkdir -p $(DEBUILD_ROOT)/usr/local/bin/
	mkdir -p $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./pgloader.1 $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./build/bin/pgloader $(DEBUILD_ROOT)/usr/local/bin/
	pkgbuild --identifier org.tapoueh.pgloader \
	         --root $(DEBUILD_ROOT)            \
	         --version $(VERSION)              \
                 ./build/pgloader-$(VERSION).pkg

latest:
	git archive --format=tar --prefix=pgloader-$(VERSION)/ v$(VERSION) \
        | gzip -9 > $(LATEST)

check: test ;

.PHONY: test pgloader-standalone

=== test/Makefile ===
TMPDIR ?= /tmp
TESTS = $(wildcard *.load)
OUT   = $(TESTS:.load=.out)

REMOTE = archive.load bossa-all.load bossa.load census-places.load dbf-zip.load
LOCAL  = $(filter-out $(REMOTE:.load=.out),$(OUT))
REGRESS= allcols.load 		    \
         csv-before-after.load 	    \
         csv-districts.load 	    \
         csv-error.load 	    \
         csv-filename-pattern.load  \
         csv-keep-extra-blanks.load \
         csv-nulls.load             \
         csv-trim-extra-blanks.load \
         csv.load 		    \
         dbf.load 		    \
         errors.load 		    \
         fixed.load 		    \
         ixf.load 		    \
         overflow.load 		    \
         partial.load 		    \
         serial.load 		    \
         udc.load 		    \
         xzero.load

PGLOADER ?= ../build/bin/pgloader

regress: clean-out $(addprefix regress/out/, $(REGRESS:.load=.out)) ;

clean-out:
	rm -f regress/out/*

local: prepare $(LOCAL)

remote: prepare $(REMOTE:.load=.out)

all: prepare $(OUT)

prepare: bossa.sql sakila
	-dropdb -U postgres pgloader
	-dropdb -U postgres stocks
	-dropdb -U postgres ip4r
	-createdb -U postgres -O `whoami` pgloader
	-createdb -U postgres -O `whoami` stocks
	-createdb -U postgres -O `whoami` ip4r
	-psql -U postgres -d pgloader -c 'create extension ip4r'
	-psql -U postgres -d ip4r -c 'create extension ip4r'
	-psql -d stocks -f bossa.sql

errors.out: errors.load
	-$(PGLOADER) $<
	@echo

nofile.out: nofile.load
	-$(PGLOADER) $<
	@echo

csv-hstore.out: csv-hstore.load
	@echo skipping $@

# sakila needs preparing a MySQL database too
$(TMPDIR)/sakila-db/sakila-schema.sql: data/sakila-db.zip
	rm -rf $(TMPDIR)/sakila-db
	unzip $< -d $(TMPDIR)

sakila: $(TMPDIR)/sakila-db/sakila-schema.sql
	-dropdb -U postgres sakila
	-createdb -U postgres -O `whoami` sakila
	-echo "DROP DATABASE sakila" | mysql -u root
	echo "SOURCE $(TMPDIR)/sakila-db/sakila-schema.sql" | mysql -u root
	echo "SOURCE $(TMPDIR)/sakila-db/sakila-data.sql"   | mysql -u root

sakila.out: sakila sakila.load
	-$(PGLOADER) sakila.load
	@echo

csv-districts-stdin.out: csv-districts-stdin.load
	cat  data/2013_Gaz_113CDs_national.txt | $(PGLOADER) $^

# General case where we do NOT expect any error
%.out: %.load
	$(PGLOADER) $<
	@echo

# Regression tests
regress/out/%.out: %.load
	./regress.sh $(PGLOADER) $<

=== debian/changelog ===
pgloader (3.1.0+dfsg-2) unstable; urgency=medium

  * Fix building on i386 machines, using 1GB of dynamic space there.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 22 Sep 2014 23:04:18 +0400

pgloader (3.1.0+dfsg-1) unstable; urgency=medium

  * Stable release of the new pgloader version, 3.1

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 10 Sep 2014 16:48:11 +0400

pgloader (3.0.99-1) unstable; urgency=medium

  * Release Candidate 9
  * Can be built against either CCL or SBCL
  * Lots of bug fixes
  * Smarted batch memory usage

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 29 Apr 2014 13:50:26 +0400

pgloader (3.0.98-1) unstable; urgency=low

  * Release Candidate 8
  * Fixes retry behavior
  * Assorted fixes

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 23 Jan 2014 03:19:07 +0400

pgloader (3.0.97-1) unstable; urgency=low

  * Release Candidate 7
  * Fix log-filename location
  * Switch to the new cl-csv version
  * Add a documentation website with tutorials
  * Fix ASDF dependencies

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 15 Jan 2014 01:33:16 +0400

pgloader (3.0.96-1) unstable; urgency=low

  * Release Candidate 6
  * Document then rework the batch retry behavior.
  * Various bug fixes, including CCL compatibility.
  
 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 27 Dec 2013 15:11:02 +0400

pgloader (3.0.95-1) unstable; urgency=low

  * Release Candidate 5.
  * Minimize memory usage, bug fixes.

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 18 Dec 2013 23:32:33 +0100

pgloader (3.0.94-1) unstable; urgency=low

  * Release Candidate 4.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 09 Dec 2013 14:58:51 +0400

pgloader (2.3.3~dev3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't hardcode dependency on python-support, use ${python:Depends}
    (closes: #542052). Thanks to Faheem Mitha for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 06 Jan 2012 02:19:25 +0100

pgloader (2.3.3~dev3-1) unstable; urgency=low

  * Implement -f --field-sep to overwrite the default from command line
  * Add support for filename arguments, which use defaults
  * Implement --reject-log and --reject-data
  * Add support for --max-parallel-sections and --section-threads
  * Support setting any PG option (-o and config file)
  * Have --debug show a traceback
  * Fix a bug where pgloader would freeze on early error (no such file)
  * Implement an option to set csv field size limit
  * Implement --load-from-stdin
  * Implement --boundaries
  * use gettempdir() rather than hard-coded "/tmp"
  * Handle C-c the default system's way
  * Fix pgloader thread error management
  * Fix exit status to be non-zero in case of known errors

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 09 Nov 2010 16:10:01 +0100

pgloader (2.3.2-1) unstable; urgency=low

  * Implement --from support in all readers (Closes: #531034)
  * Use psycopg cursor.copy_expert() when available (> 2.0.6)
  * FIX fixedreader: it now know about -C
  * FIX Round Robin Reader with respect to offsets in readlines()
  * support python 2.3 if not using RRR (not importing collections.deque)
  * change logger initialisation to support python 2.3
  * FIX bad usage of STDERR in the code
  * Implement skip_head_lines option in configuration (superseded by -F)
  * Do not sort() section list when it's been given on command line
  * Catch InterfaceError when trying to close connection

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 29 Jun 2009 09:39:33 +0200

pgloader (2.3.1-2) unstable; urgency=low

  * FIX Missing Build-Depends (Closes: #485067)

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 09 Jun 2008 15:23:56 +0200

pgloader (2.3.1-1) unstable; urgency=low

  * FIX: Add database opening into critical path (BoundedSemaphore)
  * FIX: close database connection as soon as possible
  * Add support for fixed format
  * Add support for escaped field_sep, such as \t

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 21 May 2008 12:19:42 +0200

pgloader (2.3.0-1) unstable; urgency=low

  * FIX the cluttered test case, see BUGS.txt
  * Better release it as stable now and fix bugs when found than wait for
    more testing of the ~dev release candidates.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 10 Mar 2008 15:36:04 +0100

pgloader (2.3.0~dev3-1) experimental; urgency=low

  * Add options for forcing psycopg version to use (-1, -2, --psycopg-version)

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 27 Feb 2008 12:54:46 +0100

pgloader (2.3.0~dev2-1) experimental; urgency=low

  * columns = * is now supported

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 25 Feb 2008 14:58:46 +0100

pgloader (2.3.0~dev-1) unstable; urgency=low

  * Mutli-threaded pgloader (see options max_parallel_sections,
                             section_threads and split_file_reading)
  * FIX for -C and -I options (replace sys.log with self.log), per user request

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 11 Feb 2008 15:04:40 +0100

pgloader (2.2.6-1) unstable; urgency=low

  * pgloader -V now VACUUM each table separately, no more vacuumdb issued
  * New option -D to DISABLE Triggers while loading (ENABLE them one done)

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 01 Feb 2008 11:01:34 +0100

pgloader (2.2.5-1) unstable; urgency=low

  * Now using proper python logging module
  * New client_min_messages, log_min_messages, log_file and lc_messages options
  * Better reporting of DatabaseError (pkey violation, e.g.)
  * Have logging of error data work again in all cases (DatabaseError)
  * Protect some more settings from begin overwritten when using templates

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 07 Dec 2007 23:24:58 +0100

pgloader (2.2.5~dev-1) unstable; urgency=low

  * Configuration now supports templates
  * Command line option for setting --reformat_path, -R
  * Upload to Debian (Closes: #453434)

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 26 Nov 2007 21:53:11 +0100

pgloader (2.2.4) unstable; urgency=low

  * Reformat modules to change input on-the-fly


=== debian/control ===
Source: pgloader
Section: database
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3)
Standards-Version: 3.9.5
Homepage: https://github.com/dimitri/pgloader
Vcs-Git: https://github.com/dimitri/pgloader.git
Vcs-Browser: https://github.com/dimitri/pgloader

Package: pgloader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

Package: cl-pgloader
Architecture: all
Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3)
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGVERS = $(shell dpkg-parsechangelog | awk -F '[:-]' '/^Version:/ { print substr($$2, 2) }')
EXCLUDE = --exclude-vcs --exclude=debian --exclude=build --exclude=.vagrant

BITS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITS),32)
SIZE=1024
else
SIZE=4096
endif

# buildd provides a build environment where $HOME is not writable, but the
# CL compilers here will need to fill-in a per-user cache
export HOME = $(CURDIR)/debian/home

orig: clean
	rm -rf $(HOME)
	cd .. && tar czf pgloader_$(PKGVERS).orig.tar.gz $(EXCLUDE) pgloader

override_dh_auto_build:
	make docs
	mkdir -p build/bin
	mkdir -p $(HOME)
	buildapp --require sb-posix                         \
                 --require sb-bsd-sockets                   \
                 --load /usr/share/common-lisp/source/cl-asdf/build/asdf.lisp \
                 --asdf-path .                              \
                 --asdf-tree /usr/share/common-lisp/systems \
                 --load-system asdf-finalizers         	    \
                 --load-system asdf-system-connections 	    \
                 --load-system pgloader               	    \
                 --load src/hooks.lisp                      \
                 --entry pgloader:main                      \
                 --dynamic-space-size $(SIZE)               \
                 --compress-core                    	    \
                 --output build/bin/pgloader

override_dh_auto_test:
	# no nothing

override_dh_strip:
	# do nothing

%:
	dh $@

## pgloader 3.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,18 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.1.0
+VERSION    = 3.2.0
 
 # use either sbcl or ccl
 CL	   = sbcl
 
-LISP_SRC   = $(wildcard src/*lisp) \
-             $(wildcard src/pgsql/*lisp) \
+# default to 4096 MB of RAM size in the image
+DYNSIZE    = 4096
+
+LISP_SRC   = $(wildcard src/*lisp)         \
+             $(wildcard src/monkey/*lisp)  \
+             $(wildcard src/utils/*lisp)   \
+             $(wildcard src/parsers/*lisp) \
+             $(wildcard src/pgsql/*lisp)   \
              $(wildcard src/sources/*lisp) \
              pgloader.asd
 
@@ -15,10 +21,18 @@
 QLDIR      = $(BUILDDIR)/quicklisp
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
-PGLOADER   = $(BUILDDIR)/bin/$(APP_NAME)
-
-BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl
-BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl
+
+ifeq ($(OS),Windows_NT)
+EXE           = .exe
+COMPRESS_CORE = no
+DYNSIZE       = 1024		# support for windows 32 bits
+else
+EXE =
+endif
+
+PGLOADER   = $(BUILDDIR)/bin/$(APP_NAME)$(EXE)
+BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl$(EXE)
+BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl$(EXE)
 
 ifeq ($(CL),sbcl)
 BUILDAPP   = $(BUILDAPP_SBCL)
@@ -54,8 +68,17 @@
 docs:
 	ronn -roff pgloader.1.md
 
+$(QLDIR)/local-projects/qmynd:
+	git clone https://github.com/qitab/qmynd.git $@
+
 $(QLDIR)/local-projects/cl-ixf:
 	git clone https://github.com/dimitri/cl-ixf.git $@
+
+$(QLDIR)/local-projects/cl-csv:
+	git clone https://github.com/AccelerationNet/cl-csv.git $@
+
+$(QLDIR)/local-projects/esrap:
+	git clone -b wip-better-errors https://github.com/scymtym/esrap.git $@
 
 $(QLDIR)/setup.lisp:
 	mkdir -p $(BUILDDIR)
@@ -66,7 +89,12 @@
 
 quicklisp: $(QLDIR)/setup.lisp ;
 
-$(LIBS): $(QLDIR)/setup.lisp $(QLDIR)/local-projects/cl-ixf
+clones: $(QLDIR)/local-projects/cl-ixf \
+        $(QLDIR)/local-projects/cl-csv \
+        $(QLDIR)/local-projects/qmynd  \
+        $(QLDIR)/local-projects/esrap ;
+
+$(LIBS): $(QLDIR)/setup.lisp clones
 	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
              --eval '(push "$(PWD)/" asdf:*central-registry*)'      \
              --eval '(ql:quickload "pgloader")'                     \
@@ -111,9 +139,11 @@
                          --load-system $(APP_NAME)               \
                          --load src/hooks.lisp                   \
                          --entry pgloader:main                   \
-                         --dynamic-space-size 4096               \
+                         --dynamic-space-size $(DYNSIZE)         \
                          $(COMPRESS_CORE_OPT)                    \
-                         --output $@
+                         --output $@.tmp
+	# that's ugly, but necessary when building on Windows :(
+	mv $@.tmp $@
 
 pgloader: $(PGLOADER) ;
 
@@ -123,7 +153,7 @@
                        --require sb-rotate-byte                \
                        --load-system pgloader                  \
                        --entry pgloader:main                   \
-                       --dynamic-space-size 4096               \
+                       --dynamic-space-size $(DYNSIZE)         \
                        --compress-core                         \
                        --output $(PGLOADER)

=== test/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 REGRESS= allcols.load 		    \
          csv-before-after.load 	    \
          csv-districts.load 	    \
+         csv-parse-date.load 	    \
          csv-error.load 	    \
          csv-filename-pattern.load  \
          csv-keep-extra-blanks.load \

=== debian/changelog ===
pgloader (3.2.0+dfsg-1) unstable; urgency=medium

  * Implement COPY files support
  * Implement MS SQL source database support
  * Lots of bug fixes
  * Full command line operations support
  * Misc improvements, cleanup, refactoring

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 15 Jan 2015 19:51:02 +0300

pgloader (3.1.1+dfsg-1) unstable; urgency=medium

  * Fix --root-dir option when target directory doesn't exists (Closes:#767288)
  * New release, lots of bugfixes
  * Add support for CAST rules for SQLite
  * Code refactoring
  * New file based sources filters and options
  
 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 03 Nov 2014 16:08:19 +0300

pgloader (3.1.0+dfsg-3) unstable; urgency=medium

  * Fix build dependencies problems, see Bug#765162

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 28 Oct 2014 12:41:23 +0300

=== debian/control ===
Source: pgloader
Section: database
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8
Standards-Version: 3.9.6
Homepage: https://github.com/dimitri/pgloader
Vcs-Git: https://github.com/dimitri/pgloader.git
Vcs-Browser: https://github.com/dimitri/pgloader

Package: pgloader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freetds-dev
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

Package: cl-pgloader
Architecture: all
Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-uuid, cl-trivial-utf-8
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

## pgloader 3.2.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.2.0
+VERSION    = 3.2.2
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -74,6 +74,9 @@
 $(QLDIR)/local-projects/cl-ixf:
 	git clone https://github.com/dimitri/cl-ixf.git $@
 
+$(QLDIR)/local-projects/cl-db3:
+	git clone https://github.com/dimitri/cl-db3.git $@
+
 $(QLDIR)/local-projects/cl-csv:
 	git clone https://github.com/AccelerationNet/cl-csv.git $@
 
@@ -83,13 +86,15 @@
 $(QLDIR)/setup.lisp:
 	mkdir -p $(BUILDDIR)
 	curl -o $(BUILDDIR)/quicklisp.lisp http://beta.quicklisp.org/quicklisp.lisp
-	$(CL) $(CL_OPTS) --load $(BUILDDIR)/quicklisp.lisp                         \
-             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp")' \
+	$(CL) $(CL_OPTS) --load $(BUILDDIR)/quicklisp.lisp                        \
+             --load src/getenv.lisp                                               \
+             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp" :proxy (getenv "http_proxy"))' \
              --eval '(quit)'
 
 quicklisp: $(QLDIR)/setup.lisp ;
 
 clones: $(QLDIR)/local-projects/cl-ixf \
+        $(QLDIR)/local-projects/cl-db3 \
         $(QLDIR)/local-projects/cl-csv \
         $(QLDIR)/local-projects/qmynd  \
         $(QLDIR)/local-projects/esrap ;
@@ -148,13 +153,13 @@
 pgloader: $(PGLOADER) ;
 
 pgloader-standalone:
-	$(BUILDAPP)    --require sb-posix                      \
-                       --require sb-bsd-sockets                \
-                       --require sb-rotate-byte                \
-                       --load-system pgloader                  \
+	$(BUILDAPP)    $(BUILDAPP_OPTS)                        \
+                       --sbcl $(CL)                            \
+                       --load-system $(APP_NAME)               \
+                       --load src/hooks.lisp                   \
                        --entry pgloader:main                   \
                        --dynamic-space-size $(DYNSIZE)         \
-                       --compress-core                         \
+                       $(COMPRESS_CORE_OPT)                    \
                        --output $(PGLOADER)
 
 test: $(PGLOADER)

=== test/Makefile ===
--- 
+++ 
@@ -9,14 +9,21 @@
          csv-districts.load 	    \
          csv-parse-date.load 	    \
          csv-error.load 	    \
+         csv-escape-mode.load 	    \
          csv-filename-pattern.load  \
+         csv-header.load            \
+         csv-json.load              \
          csv-keep-extra-blanks.load \
+         csv-non-printable.load     \
          csv-nulls.load             \
          csv-trim-extra-blanks.load \
          csv.load 		    \
+	 copy.load                  \
+	 copy-hex.load              \
          dbf.load 		    \
          errors.load 		    \
          fixed.load 		    \
+         fields-with-periods.load   \
          ixf.load 		    \
          overflow.load 		    \
          partial.load 		    \

=== debian/changelog ===
pgloader (3.2.2+dfsg-1) unstable; urgency=medium

  * New release, lots of bugfixes, some new features
  * New build dependencies

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 03 Sep 2015 19:17:12 +0300

pgloader (3.2.1~preview+dfsg-2) unstable; urgency=medium

  * Interim bugfix release

 --  Dimitri Fontaine <dim@tapoueh.org>  Thu, 22 Jan 2015 04:06:51 +0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Dimitri Fontaine <dim@tapoueh.org>
 Uploaders: Christoph Berg <myon@debian.org>
-Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8
+Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities
 Standards-Version: 3.9.6
 Homepage: https://github.com/dimitri/pgloader
 Vcs-Git: https://github.com/dimitri/pgloader.git
@@ -28,7 +28,7 @@
 
 Package: cl-pgloader
 Architecture: all
-Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-uuid, cl-trivial-utf-8
+Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities
 Description: extract, transform and load data into PostgreSQL
  pgloader imports data from different kind of sources and COPY it into
  PostgreSQL.

## pgloader 3.3.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # pgloader build tool
 APP_NAME   = pgloader
-VERSION    = 3.2.2
+VERSION    = 3.3.1
 
 # use either sbcl or ccl
 CL	   = sbcl
@@ -21,6 +21,9 @@
 QLDIR      = $(BUILDDIR)/quicklisp
 MANIFEST   = $(BUILDDIR)/manifest.ql
 LATEST     = $(BUILDDIR)/pgloader-latest.tgz
+BUNDLENAME = pgloader-bundle-$(VERSION)
+BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
+BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz
 
 ifeq ($(OS),Windows_NT)
 EXE           = .exe
@@ -35,27 +38,26 @@
 BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl$(EXE)
 
 ifeq ($(CL),sbcl)
-BUILDAPP   = $(BUILDAPP_SBCL)
-CL_OPTS    = --no-sysinit --no-userinit
+BUILDAPP      = $(BUILDAPP_SBCL)
+BUILDAPP_OPTS = --require sb-posix                      \
+                --require sb-bsd-sockets                \
+                --require sb-rotate-byte
+CL_OPTS    = --noinform --no-sysinit --no-userinit
 else
 BUILDAPP   = $(BUILDAPP_CCL)
 CL_OPTS    = --no-init
 endif
 
-COMPRESS_CORE ?= yes
-
 ifeq ($(CL),sbcl)
+COMPRESS_CORE ?= $(shell $(CL) --noinform \
+                               --quit     \
+                               --eval '(when (member :sb-core-compression cl:*features*) (write-string "yes"))')
+
+endif
+
+# note: on Windows_NT, we never core-compress; see above.
 ifeq ($(COMPRESS_CORE),yes)
 COMPRESS_CORE_OPT = --compress-core
-else
-COMPRESS_CORE_OPT = 
-endif
-endif
-
-ifeq ($(CL),sbcl)
-BUILDAPP_OPTS =          --require sb-posix                      \
-                         --require sb-bsd-sockets                \
-                         --require sb-rotate-byte
 endif
 
 DEBUILD_ROOT = /tmp/pgloader
@@ -69,19 +71,16 @@
 	ronn -roff pgloader.1.md
 
 $(QLDIR)/local-projects/qmynd:
-	git clone https://github.com/qitab/qmynd.git $@
+	git clone --depth 1 https://github.com/qitab/qmynd.git $@
 
 $(QLDIR)/local-projects/cl-ixf:
-	git clone https://github.com/dimitri/cl-ixf.git $@
+	git clone --depth 1 https://github.com/dimitri/cl-ixf.git $@
 
 $(QLDIR)/local-projects/cl-db3:
-	git clone https://github.com/dimitri/cl-db3.git $@
+	git clone --depth 1 https://github.com/dimitri/cl-db3.git $@
 
 $(QLDIR)/local-projects/cl-csv:
-	git clone https://github.com/AccelerationNet/cl-csv.git $@
-
-$(QLDIR)/local-projects/esrap:
-	git clone -b wip-better-errors https://github.com/scymtym/esrap.git $@
+	git clone --depth 1 https://github.com/AccelerationNet/cl-csv.git $@
 
 $(QLDIR)/setup.lisp:
 	mkdir -p $(BUILDDIR)
@@ -96,8 +95,7 @@
 clones: $(QLDIR)/local-projects/cl-ixf \
         $(QLDIR)/local-projects/cl-db3 \
         $(QLDIR)/local-projects/cl-csv \
-        $(QLDIR)/local-projects/qmynd  \
-        $(QLDIR)/local-projects/esrap ;
+        $(QLDIR)/local-projects/qmynd ;
 
 $(LIBS): $(QLDIR)/setup.lisp clones
 	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
@@ -161,9 +159,34 @@
                        --dynamic-space-size $(DYNSIZE)         \
                        $(COMPRESS_CORE_OPT)                    \
                        --output $(PGLOADER)
-
 test: $(PGLOADER)
 	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C test regress
+
+clean-bundle:
+	rm -rf $(BUNDLEDIR)
+
+$(BUNDLEDIR):
+	mkdir -p $@
+	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
+             --eval '(ql:bundle-systems (list "pgloader" "buildapp") :to "$@")' \
+             --eval '(quit)'
+
+$(BUNDLE): $(BUNDLEDIR)
+	cp bundle/README.md $(BUNDLEDIR)
+	sed -e s/%VERSION%/$(VERSION)/ < bundle/Makefile > $(BUNDLEDIR)/Makefile
+	git archive --format=tar --prefix=pgloader-$(VERSION)/ master \
+	     | tar -C $(BUNDLEDIR)/local-projects/ -xf -
+	make QLDIR=$(BUNDLEDIR) clones
+	tar -C build/bundle 		    \
+            --exclude bin   		    \
+            --exclude test/sqlite           \
+            -czf $@ pgloader-bundle-$(VERSION)
+
+bundle: $(BUNDLE)
+
+test-bundle:
+	$(MAKE) -C $(BUNDLEDIR) test
+
 
 deb:
 	# intended for use on a debian system

=== debian/changelog ===
pgloader (3.3.1+dfsg-2) unstable; urgency=medium

  * Add tzdata to build-depends (Closes: #839468)

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 03 Nov 2016 14:32:28 +0100

pgloader (3.3.1+dfsg-1) unstable; urgency=medium

  * New release, bugfixes and new features

 -- Dimitri Fontaine <dim@tapoueh.org>  Sun, 28 Aug 2016 21:07:47 +0300
